IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include c:\masm32\include\masm32rt.inc

    atou      PROTO :DWORD
    atou_ex   PROTO :DWORD

    iter equ <5000000>

    ncnt equ <4>
    padd equ <db 0>
    algn equ <8>

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    print "atodw Version",13,10,13,10

    print ustr$(rv(atodw,"4294967295")),13,10
    print ustr$(rv(atodw,"987")),13,10
    print ustr$(rv(atodw,"0")),13,10
    print ustr$(rv(atodw,"9876")),13,10

    print chr$(13,10),"Short Version",13,10,13,10

    print ustr$(rv(atou,"4294967295")),13,10
    print ustr$(rv(atou,"987")),13,10
    print ustr$(rv(atou,"0")),13,10
    print ustr$(rv(atou,"9876")),13,10

    print chr$(13,10),"Long Version",13,10,13,10

    print ustr$(rv(atou_ex,"4294967295")),13,10
    print ustr$(rv(atou_ex,"987")),13,10
    print ustr$(rv(atou_ex,"0")),13,10
    print ustr$(rv(atou_ex,"9876")),13,10

    push ebx
    push esi
    push edi

    invoke SetPriorityClass,rv(GetCurrentProcess),HIGH_PRIORITY_CLASS

    print "-------",13,10
    print "Timings",13,10
    print "-------",13,10,13,10

  ; ---------------------------------------------

    print "Timing atodw version",13,10

    invoke GetTickCount
    push eax

    mov esi, iter

  @@::
    fn atodw,"4294967295"
    fn atodw,"9876543"
    fn atodw,"1234"
    fn atodw,"0"
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax),13,10,13,10

    invoke SleepEx, 500, 0

  ; ---------------------------------------------
 
    print "Timing short version",13,10

    invoke GetTickCount
    push eax

    mov esi, iter

  lbl0:
    fn atou,"4294967295"
    fn atou,"9876543"
    fn atou,"1234"
    fn atou,"0"
    sub esi, 1
    jnz lbl0

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax),13,10,13,10

    invoke SleepEx, 500, 0

  ; ---------------------------------------------

    print "Timing long version",13,10

    invoke GetTickCount
    push eax

    mov esi, iter

  lbl1:
    fn atou_ex,"4294967295"
    fn atou_ex,"9876543"
    fn atou_ex,"1234"
    fn atou_ex,"0"
    sub esi, 1
    jnz lbl1

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax),13,10,13,10

    invoke SleepEx, 500, 0

  ; ---------------------------------------------

    invoke SetPriorityClass,rv(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    pop edi
    pop esi
    pop ebx

    ret

main endp

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

    REPEAT ncnt
      padd
    ENDM

align algn

atou proc String:DWORD
  ; ------------------------------------------------
  ; Convert decimal string into UNSIGNED DWORD value
  ; ------------------------------------------------
    mov		edx, [esp+4]
    movzx	eax, byte ptr [edx]
	add		edx, 1
    test		eax, eax
    jz			quite3
    movzx ecx, byte ptr [edx]
	sub		eax, 30h
    test		ecx, ecx
    jz			quite3
@@:
    inc			edx
    lea			eax, [eax+eax*4]
    cmp         byte ptr [edx], 0 
    lea           eax, [ecx+eax*2-30h]
    movzx    ecx, byte ptr [edx]
    jnz          @b
  quite3:
	pop ecx
	pop edx
	jmp ecx
atou endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

    REPEAT ncnt
      padd
    ENDM

align algn

atou_ex proc String:DWORD

  ; ------------------------------------------------
  ; Convert decimal string into UNSIGNED DWORD value
  ; ------------------------------------------------

    mov edx, [esp+4]

    xor ecx, ecx
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+1]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+2]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+3]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+4]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+5]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+6]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+7]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+8]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+9]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+10]
    test eax, eax
    jnz out_of_range

  quit:
    lea eax, [ecx]      ; return value in EAX
    or ecx, -1          ; non zero in ECX for success
    ret 4

  out_of_range:
    xor eax, eax        ; zero return value on error
    xor ecx, ecx        ; zero in ECX is out of range error
    ret 4

atou_ex endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

    REPEAT ncnt
      padd
    ENDM

end start
